Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.sql
Interface DatabaseMetaData

public interface DatabaseMetaData

Comprehensive information about the database as a whole.

Many of the methods here return lists of information in the form of `ResultSet` objects. You can use the normal `ResultSet` methods such as getString and getInt to retrieve the data from these `ResultSet`. If a given form of metadata is not available, these methods should throw an SQLException.

Some of these methods take arguments that are String patterns. These arguments all have names such as fooPattern. Within a pattern String, "%" means match any substring of 0 or more characters, and "_" means match any one character. Only metadata entries matching the search pattern are returned. If a search pattern argument is set to a null ref, that argument's criteria will be dropped from the search.

An `SQLException` will be thrown if a driver does not support a meta data method. In the case of methods that return a `ResultSet`, either a `ResultSet` (which may be empty) is returned or a SQLException is thrown.

Field Summary
`static int` | `bestRowNotPseudo` Indicates that the best row identifier is NOT a pseudo column.
`static int` | `bestRowPseudo` Indicates that the best row identifier is a pseudo column.
`static int` | `bestRowSession` Indicates that the scope of the best row identifier is the remainder of the current session.
`static int` | `bestRowTemporary` Indicates that the scope of the best row identifier is very temporary, lasting only while the row is being used.
`static int` | `bestRowTransaction` Indicates that the scope of the best row identifier is the remainder of the current transaction.
`static int` | `bestRowUnknown` Indicates that the best row identifier may or may not be a pseudo column.
`static int` | `columnNoNulls` Indicates that the column might not allow NULL values.
`static int` | `columnNullable` Indicates that the column definitely allows `NULL` values.
`static int` | `columnNullableUnknown` Indicates that the nullability of columns is unknown.
`static int` | `importedKeyCascade` A possible value for the columns `UPDATE_RULE` and `DELETE_RULE` in the `ResultSet` objects returned by the methods `getImportedKeys`, `getExportedKeys`, and `getCrossReference`.
`static int` | `importedKeyInitiallyDeferred` A possible value for the column `DEFERRABILITY` in the `ResultSet` objects returned by the methods `getImportedKeys`, `getExportedKeys`, and `getCrossReference`.
`static int` | `importedKeyInitiallyImmediate` A possible value for the column `DEFERRABILITY` in the `ResultSet` objects returned by the methods `getImportedKeys`, `getExportedKeys`, and `getCrossReference`.
`static int` | `importedKeyNoAction` A possible value for the columns `UPDATE_RULE` and `DELETE_RULE` in the `ResultSet` objects returned by the methods `getImportedKeys`, `getExportedKeys`, and `getCrossReference`.
`static int` | `importedKeyNotDeferrable` A possible value for the column `DEFERRABILITY` in the `ResultSet` objects returned by the methods `getImportedKeys`, `getExportedKeys`, and `getCrossReference`.
`static int` | `importedKeyRestrict` A possible value for the columns `UPDATE_RULE` and `DELETE_RULE` in the `ResultSet` objects returned by the methods `getImportedKeys`, `getExportedKeys`, and `getCrossReference`.
`static int` | `importedKeySetDefault` A possible value for the columns `UPDATE_RULE` and `DELETE_RULE` in the `ResultSet` objects returned by the methods `getImportedKeys`, `getExportedKeys`, and `getCrossReference`.
`static int` | `importedKeySetNull` A possible value for the columns `UPDATE_RULE` and `DELETE_RULE` in the `ResultSet` objects returned by the methods `getImportedKeys`, `getExportedKeys`, and `getCrossReference`.
`static int` | `procedureColumnIn` Indicates that the column stores IN parameters.
`static int` | `procedureColumnInOut` Indicates that the column stores INOUT parameters.
`static int` | `procedureColumnOut` Indicates that the column stores OUT parameters.
`static int` | `procedureColumnResult` Indicates that the column stores results.
`static int` | `procedureColumnReturn` Indicates that the column stores return values.
`static int` | `procedureColumnUnknown` Indicates that type of the column is unknown.
`static int` | `procedureNoNulls` Indicates that `NULL` values are not allowed.
`static int` | `procedureNoResult` A possible value for column `PROCEDURE_TYPE` in the `ResultSet` object returned by the method `getProcedures`.
`static int` | `procedureNullable` Indicates that `NULL` values are allowed.
`static int` | `procedureNullableUnknown` Indicates that whether `NULL` values are allowed is unknown.
`static int` | `procedureResultUnknown` A possible value for column `PROCEDURE_TYPE` in the `ResultSet` object returned by the method `getProcedures`.
`static int` | `procedureReturnsResult` A possible value for column `PROCEDURE_TYPE` in the `ResultSet` object returned by the method `getProcedures`.
`static short` | `tableIndexClustered` A possible value for column `TYPE` in the `ResultSet` object returned by the method `getIndexInfo`.
`static short` | `tableIndexHashed` A possible value for column `TYPE` in the `ResultSet` object returned by the method `getIndexInfo`.
`static short` | `tableIndexOther` A possible value for column `TYPE` in the `ResultSet` object returned by the method `getIndexInfo`.
`static short` | `tableIndexStatistic` A possible value for column `TYPE` in the `ResultSet` object returned by the method `getIndexInfo`.
`static int` | `typeNoNulls` A possible value for column `NULLABLE` in the `ResultSet` object returned by the method `getTypeInfo`.
`static int` | `typeNullable` A possible value for column `NULLABLE` in the `ResultSet` object returned by the method `getTypeInfo`.
`static int` | `typeNullableUnknown` A possible value for column `NULLABLE` in the `ResultSet` object returned by the method `getTypeInfo`.
`static int` | `typePredBasic` A possible value for column `SEARCHABLE` in the `ResultSet` object returned by the method `getTypeInfo`.
`static int` | `typePredChar` A possible value for column `SEARCHABLE` in the `ResultSet` object returned by the method `getTypeInfo`.
`static int` | `typePredNone` A possible value for column `SEARCHABLE` in the `ResultSet` object returned by the method `getTypeInfo`.
`static int` | `typeSearchable` A possible value for column `SEARCHABLE` in the `ResultSet` object returned by the method `getTypeInfo`.
`static int` | `versionColumnNotPseudo` Indicates that this version column is NOT a pseudo column.
`static int` | `versionColumnPseudo` Indicates that this version column is a pseudo column.
`static int` | `versionColumnUnknown` Indicates that this version column may or may not be a pseudo column.

Method Summary
`boolean` | `allProceduresAreCallable()` Can all the procedures returned by getProcedures be called by the current user?
`boolean` | `allTablesAreSelectable()` Can all the tables returned by getTable be SELECTed by the current user?
`boolean` | `dataDefinitionCausesTransactionCommit()` Does a data definition statement within a transaction force the transaction to commit?
`boolean` | `dataDefinitionIgnoredInTransactions()` Is a data definition statement within a transaction ignored?
`boolean` | `deletesAreDetected(int type)` Indicates whether or not a visible row delete can be detected by calling ResultSet.rowDeleted().
`boolean` | `doesMaxRowSizeIncludeBlobs()` Did getMaxRowSize() include LONGVARCHAR and LONGVARBINARY blobs?
`ResultSet` | `getBestRowIdentifier(String catalog, String schema, String table, int scope, boolean nullable)` Gets a description of a table's optimal set of columns that uniquely identifies a row.
`ResultSet` | `getCatalogs()` Gets the catalog names available in this database.
`String` | `getCatalogSeparator()` What's the separator between catalog and table name?
`String` | `getCatalogTerm()` What's the database vendor's preferred term for "catalog"?
`ResultSet` | `getColumnPrivileges(String catalog, String schema, String table, String columnNamePattern)` Gets a description of the access rights for a table's columns.
`ResultSet` | `getColumns(String catalog, String schemaPattern, String tableNamePattern, String columnNamePattern)` Gets a description of table columns available in the specified catalog.
`Connection` | `getConnection()` Retrieves the connection that produced this metadata object.
`ResultSet` | `getCrossReference(String primaryCatalog, String primarySchema, String primaryTable, String foreignCatalog, String foreignSchema, String foreignTable)` Gets a description of the foreign key columns in the foreign key table that reference the primary key columns of the primary key table (describe how one table imports another's key.) This should normally return a single foreign key/primary key pair (most tables only import a foreign key from a table once.) They are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and KEY_SEQ.
`String` | `getDatabaseProductName()` What's the name of this database product?
`String` | `getDatabaseProductVersion()` What's the version of this database product?
`int` | `getDefaultTransactionIsolation()` What's the database's default transaction isolation level? The values are defined in `java.sql.Connection`.
`int` | `getDriverMajorVersion()` What's this JDBC driver's major version number?
`int` | `getDriverMinorVersion()` What's this JDBC driver's minor version number?
`String` | `getDriverName()` What's the name of this JDBC driver?
`String` | `getDriverVersion()` What's the version of this JDBC driver?
`ResultSet` | `getExportedKeys(String catalog, String schema, String table)` Gets a description of the foreign key columns that reference a table's primary key columns (the foreign keys exported by a table).
`String` | `getExtraNameCharacters()` Gets all the "extra" characters that can be used in unquoted identifier names (those beyond a-z, A-Z, 0-9 and _).
`String` | `getIdentifierQuoteString()` What's the string used to quote SQL identifiers? This returns a space " " if identifier quoting isn't supported.
`ResultSet` | `getImportedKeys(String catalog, String schema, String table)` Gets a description of the primary key columns that are referenced by a table's foreign key columns (the primary keys imported by a table).
`ResultSet` | `getIndexInfo(String catalog, String schema, String table, boolean unique, boolean approximate)` Gets a description of a table's indices and statistics.
`int` | `getMaxBinaryLiteralLength()` How many hex characters can you have in an inline binary literal?
`int` | `getMaxCatalogNameLength()` What's the maximum length of a catalog name?
`int` | `getMaxCharLiteralLength()` What's the max length for a character literal?
`int` | `getMaxColumnNameLength()` What's the limit on column name length?
`int` | `getMaxColumnsInGroupBy()` What's the maximum number of columns in a "GROUP BY" clause?
`int` | `getMaxColumnsInIndex()` What's the maximum number of columns allowed in an index?
`int` | `getMaxColumnsInOrderBy()` What's the maximum number of columns in an "ORDER BY" clause?
`int` | `getMaxColumnsInSelect()` What's the maximum number of columns in a "SELECT" list?
`int` | `getMaxColumnsInTable()` What's the maximum number of columns in a table?
`int` | `getMaxConnections()` How many active connections can we have at a time to this database?
`int` | `getMaxCursorNameLength()` What's the maximum cursor name length?
`int` | `getMaxIndexLength()` Retrieves the maximum number of bytes for an index, including all of the parts of the index.
`int` | `getMaxProcedureNameLength()` What's the maximum length of a procedure name?
`int` | `getMaxRowSize()` What's the maximum length of a single row?
`int` | `getMaxSchemaNameLength()` What's the maximum length allowed for a schema name?
`int` | `getMaxStatementLength()` What's the maximum length of an SQL statement?
`int` | `getMaxStatements()` How many active statements can we have open at one time to this database?
`int` | `getMaxTableNameLength()` What's the maximum length of a table name?
`int` | `getMaxTablesInSelect()` What's the maximum number of tables in a SELECT statement?
`int` | `getMaxUserNameLength()` What's the maximum length of a user name?
`String` | `getNumericFunctions()` Gets a comma-separated list of math functions.
`ResultSet` | `getPrimaryKeys(String catalog, String schema, String table)` Gets a description of a table's primary key columns.
`ResultSet` | `getProcedureColumns(String catalog, String schemaPattern, String procedureNamePattern, String columnNamePattern)` Gets a description of a catalog's stored procedure parameters and result columns.
`ResultSet` | `getProcedures(String catalog, String schemaPattern, String procedureNamePattern)` Gets a description of the stored procedures available in a catalog.
`String` | `getProcedureTerm()` What's the database vendor's preferred term for "procedure"?
`ResultSet` | `getSchemas()` Gets the schema names available in this database.
`String` | `getSchemaTerm()` What's the database vendor's preferred term for "schema"?
`String` | `getSearchStringEscape()` Gets the string that can be used to escape wildcard characters.
`String` | `getSQLKeywords()` Gets a comma-separated list of all a database's SQL keywords that are NOT also SQL92 keywords.
`String` | `getStringFunctions()` Gets a comma-separated list of string functions.
`String` | `getSystemFunctions()` Gets a comma-separated list of system functions.
`ResultSet` | `getTablePrivileges(String catalog, String schemaPattern, String tableNamePattern)` Gets a description of the access rights for each table available in a catalog.
`ResultSet` | `getTables(String catalog, String schemaPattern, String tableNamePattern, String[] types)` Gets a description of tables available in a catalog.
`ResultSet` | `getTableTypes()` Gets the table types available in this database.
`String` | `getTimeDateFunctions()` Gets a comma-separated list of time and date functions.
`ResultSet` | `getTypeInfo()` Gets a description of all the standard SQL types supported by this database.
`ResultSet` | `getUDTs(String catalog, String schemaPattern, String typeNamePattern, int[] types)` Gets a description of the user-defined types defined in a particular schema.
`String` | `getURL()` What's the url for this database?
`String` | `getUserName()` What's our user name as known to the database?
`ResultSet` | `getVersionColumns(String catalog, String schema, String table)` Gets a description of a table's columns that are automatically updated when any value in a row is updated.
`boolean` | `insertsAreDetected(int type)` Indicates whether or not a visible row insert can be detected by calling ResultSet.rowInserted().
`boolean` | `isCatalogAtStart()` Does a catalog appear at the start of a qualified table name? (Otherwise it appears at the end)
`boolean` | `isReadOnly()` Is the database in read-only mode?
`boolean` | `nullPlusNonNullIsNull()` Are concatenations between NULL and non-NULL values NULL? For SQL-92 compliance, a JDBC technology-enabled driver will return `true`.
`boolean` | `nullsAreSortedAtEnd()` Are NULL values sorted at the end regardless of sort order?
`boolean` | `nullsAreSortedAtStart()` Are NULL values sorted at the start regardless of sort order?
`boolean` | `nullsAreSortedHigh()` Are NULL values sorted high?
`boolean` | `nullsAreSortedLow()` Are NULL values sorted low?
`boolean` | `othersDeletesAreVisible(int type)` Indicates whether deletes made by others are visible.
`boolean` | `othersInsertsAreVisible(int type)` Indicates whether inserts made by others are visible.
`boolean` | `othersUpdatesAreVisible(int type)` Indicates whether updates made by others are visible.
`boolean` | `ownDeletesAreVisible(int type)` Indicates whether a result set's own deletes are visible.
`boolean` | `ownInsertsAreVisible(int type)` Indicates whether a result set's own inserts are visible.
`boolean` | `ownUpdatesAreVisible(int type)` Indicates whether a result set's own updates are visible.
`boolean` | `storesLowerCaseIdentifiers()` Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in lower case?
`boolean` | `storesLowerCaseQuotedIdentifiers()` Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in lower case?
`boolean` | `storesMixedCaseIdentifiers()` Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in mixed case?
`boolean` | `storesMixedCaseQuotedIdentifiers()` Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in mixed case?
`boolean` | `storesUpperCaseIdentifiers()` Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in upper case?
`boolean` | `storesUpperCaseQuotedIdentifiers()` Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in upper case?
`boolean` | `supportsAlterTableWithAddColumn()` Is "ALTER TABLE" with add column supported?
`boolean` | `supportsAlterTableWithDropColumn()` Is "ALTER TABLE" with drop column supported?
`boolean` | `supportsANSI92EntryLevelSQL()` Is the ANSI92 entry level SQL grammar supported? All JDBC CompliantTM drivers must return true.
`boolean` | `supportsANSI92FullSQL()` Is the ANSI92 full SQL grammar supported?
`boolean` | `supportsANSI92IntermediateSQL()` Is the ANSI92 intermediate SQL grammar supported?
`boolean` | `supportsBatchUpdates()` Indicates whether the driver supports batch updates.
`boolean` | `supportsCatalogsInDataManipulation()` Can a catalog name be used in a data manipulation statement?
`boolean` | `supportsCatalogsInIndexDefinitions()` Can a catalog name be used in an index definition statement?
`boolean` | `supportsCatalogsInPrivilegeDefinitions()` Can a catalog name be used in a privilege definition statement?
`boolean` | `supportsCatalogsInProcedureCalls()` Can a catalog name be used in a procedure call statement?
`boolean` | `supportsCatalogsInTableDefinitions()` Can a catalog name be used in a table definition statement?
`boolean` | `supportsColumnAliasing()` Is column aliasing supported?
`boolean` | `supportsConvert()` Is the CONVERT function between SQL types supported?
`boolean` | `supportsConvert(int fromType, int toType)` Is CONVERT between the given SQL types supported?
`boolean` | `supportsCoreSQLGrammar()` Is the ODBC Core SQL grammar supported?
`boolean` | `supportsCorrelatedSubqueries()` Are correlated subqueries supported? A JDBC CompliantTM driver always returns true.
`boolean` | `supportsDataDefinitionAndDataManipulationTransactions()` Are both data definition and data manipulation statements within a transaction supported?
`boolean` | `supportsDataManipulationTransactionsOnly()` Are only data manipulation statements within a transaction supported?
`boolean` | `supportsDifferentTableCorrelationNames()` If table correlation names are supported, are they restricted to be different from the names of the tables?
`boolean` | `supportsExpressionsInOrderBy()` Are expressions in "ORDER BY" lists supported?
`boolean` | `supportsExtendedSQLGrammar()` Is the ODBC Extended SQL grammar supported?
`boolean` | `supportsFullOuterJoins()` Are full nested outer joins supported?
`boolean` | `supportsGroupBy()` Is some form of "GROUP BY" clause supported?
`boolean` | `supportsGroupByBeyondSelect()` Can a "GROUP BY" clause add columns not in the SELECT provided it specifies all the columns in the SELECT?
`boolean` | `supportsGroupByUnrelated()` Can a "GROUP BY" clause use columns not in the SELECT?
`boolean` | `supportsIntegrityEnhancementFacility()` Is the SQL Integrity Enhancement Facility supported?
`boolean` | `supportsLikeEscapeClause()` Is the escape character in "LIKE" clauses supported? A JDBC CompliantTM driver always returns true.
`boolean` | `supportsLimitedOuterJoins()` Is there limited support for outer joins? (This will be true if supportFullOuterJoins is true.)
`boolean` | `supportsMinimumSQLGrammar()` Is the ODBC Minimum SQL grammar supported? All JDBC CompliantTM drivers must return true.
`boolean` | `supportsMixedCaseIdentifiers()` Does the database treat mixed case unquoted SQL identifiers as case sensitive and as a result store them in mixed case? A JDBC CompliantTM driver will always return false.
`boolean` | `supportsMixedCaseQuotedIdentifiers()` Does the database treat mixed case quoted SQL identifiers as case sensitive and as a result store them in mixed case? A JDBC CompliantTM driver will always return true.
`boolean` | `supportsMultipleResultSets()` Are multiple `ResultSet` from a single execute supported?
`boolean` | `supportsMultipleTransactions()` Can we have multiple transactions open at once (on different connections)?
`boolean` | `supportsNonNullableColumns()` Can columns be defined as non-nullable? A JDBC CompliantTM driver always returns true.
`boolean` | `supportsOpenCursorsAcrossCommit()` Can cursors remain open across commits?
`boolean` | `supportsOpenCursorsAcrossRollback()` Can cursors remain open across rollbacks?
`boolean` | `supportsOpenStatementsAcrossCommit()` Can statements remain open across commits?
`boolean` | `supportsOpenStatementsAcrossRollback()` Can statements remain open across rollbacks?
`boolean` | `supportsOrderByUnrelated()` Can an "ORDER BY" clause use columns not in the SELECT statement?
`boolean` | `supportsOuterJoins()` Is some form of outer join supported?
`boolean` | `supportsPositionedDelete()` Is positioned DELETE supported?
`boolean` | `supportsPositionedUpdate()` Is positioned UPDATE supported?
`boolean` | `supportsResultSetConcurrency(int type, int concurrency)` Does the database support the concurrency type in combination with the given result set type?
`boolean` | `supportsResultSetType(int type)` Does the database support the given result set type?
`boolean` | `supportsSchemasInDataManipulation()` Can a schema name be used in a data manipulation statement?
`boolean` | `supportsSchemasInIndexDefinitions()` Can a schema name be used in an index definition statement?
`boolean` | `supportsSchemasInPrivilegeDefinitions()` Can a schema name be used in a privilege definition statement?
`boolean` | `supportsSchemasInProcedureCalls()` Can a schema name be used in a procedure call statement?
`boolean` | `supportsSchemasInTableDefinitions()` Can a schema name be used in a table definition statement?
`boolean` | `supportsSelectForUpdate()` Is SELECT for UPDATE supported?
`boolean` | `supportsStoredProcedures()` Are stored procedure calls using the stored procedure escape syntax supported?
`boolean` | `supportsSubqueriesInComparisons()` Are subqueries in comparison expressions supported? A JDBC CompliantTM driver always returns true.
`boolean` | `supportsSubqueriesInExists()` Are subqueries in 'exists' expressions supported? A JDBC CompliantTM driver always returns true.
`boolean` | `supportsSubqueriesInIns()` Are subqueries in 'in' statements supported? A JDBC CompliantTM driver always returns true.
`boolean` | `supportsSubqueriesInQuantifieds()` Are subqueries in quantified expressions supported? A JDBC CompliantTM driver always returns true.
`boolean` | `supportsTableCorrelationNames()` Are table correlation names supported? A JDBC CompliantTM driver always returns true.
`boolean` | `supportsTransactionIsolationLevel(int level)` Does this database support the given transaction isolation level?
`boolean` | `supportsTransactions()` Are transactions supported? If not, invoking the method `commit` is a noop and the isolation level is TRANSACTION_NONE.
`boolean` | `supportsUnion()` Is SQL UNION supported?
`boolean` | `supportsUnionAll()` Is SQL UNION ALL supported?
`boolean` | `updatesAreDetected(int type)` Indicates whether or not a visible row update can be detected by calling the method `ResultSet.rowUpdated`.
`boolean` | `usesLocalFilePerTable()` Does the database use a file for each table?
`boolean` | `usesLocalFiles()` Does the database store tables in a local file?

Field Detail

### procedureResultUnknown

    public static final int procedureResultUnknown

  A possible value for column `PROCEDURE_TYPE` in the `ResultSet` object returned by the method `getProcedures`.

  Indicates that it is not known whether the procedure returns a result.

### procedureNoResult

    public static final int procedureNoResult

  A possible value for column `PROCEDURE_TYPE` in the `ResultSet` object returned by the method `getProcedures`.

  Indicates that the procedure does not return a result.

### procedureReturnsResult

    public static final int procedureReturnsResult

  A possible value for column `PROCEDURE_TYPE` in the `ResultSet` object returned by the method `getProcedures`.

  Indicates that the procedure returns a result.

### procedureColumnUnknown

    public static final int procedureColumnUnknown

  Indicates that type of the column is unknown. A possible value for the column `COLUMN_TYPE` in the `ResultSet` returned by the method `getProcedureColumns`.

### procedureColumnIn

    public static final int procedureColumnIn

  Indicates that the column stores IN parameters. A possible value for the column `COLUMN_TYPE` in the `ResultSet` returned by the method `getProcedureColumns`.

### procedureColumnInOut

    public static final int procedureColumnInOut

  Indicates that the column stores INOUT parameters. A possible value for the column `COLUMN_TYPE` in the `ResultSet` returned by the method `getProcedureColumns`.

### procedureColumnOut

    public static final int procedureColumnOut

  Indicates that the column stores OUT parameters. A possible value for the column `COLUMN_TYPE` in the `ResultSet` returned by the method `getProcedureColumns`.

### procedureColumnReturn

    public static final int procedureColumnReturn

  Indicates that the column stores return values. A possible value for the column `COLUMN_TYPE` in the `ResultSet` returned by the method `getProcedureColumns`.

### procedureColumnResult

    public static final int procedureColumnResult

  Indicates that the column stores results. A possible value for the column `COLUMN_TYPE` in the `ResultSet` returned by the method `getProcedureColumns`.

### procedureNoNulls

    public static final int procedureNoNulls

  Indicates that `NULL` values are not allowed. A possible value for the column `NULLABLE` in the `ResultSet` returned by the method `getProcedureColumns`.

### procedureNullable

    public static final int procedureNullable

  Indicates that `NULL` values are allowed. A possible value for the column `NULLABLE` in the `ResultSet` returned by the method `getProcedureColumns`.

### procedureNullableUnknown

    public static final int procedureNullableUnknown

  Indicates that whether `NULL` values are allowed is unknown. A possible value for the column `NULLABLE` in the `ResultSet` returned by the method `getProcedureColumns`.

### columnNoNulls

    public static final int columnNoNulls

  Indicates that the column might not allow NULL values. A possible value for the column `NULLABLE` in the `ResultSet` returned by the method `getColumns`.

### columnNullable

    public static final int columnNullable

  Indicates that the column definitely allows `NULL` values. A possible value for the column `NULLABLE` in the `ResultSet` returned by the method `getColumns`.

### columnNullableUnknown

    public static final int columnNullableUnknown

  Indicates that the nullability of columns is unknown. A possible value for the column `NULLABLE` in the `ResultSet` returned by the method `getColumns`.

### bestRowTemporary

    public static final int bestRowTemporary

  Indicates that the scope of the best row identifier is very temporary, lasting only while the row is being used. A possible value for the column `SCOPE` in the `ResultSet` object returned by the method `getBestRowIdentifier`.

### bestRowTransaction

    public static final int bestRowTransaction

  Indicates that the scope of the best row identifier is the remainder of the current transaction. A possible value for the column `SCOPE` in the `ResultSet` object returned by the method `getBestRowIdentifier`.

### bestRowSession

    public static final int bestRowSession

  Indicates that the scope of the best row identifier is the remainder of the current session. A possible value for the column `SCOPE` in the `ResultSet` object returned by the method `getBestRowIdentifier`.

### bestRowUnknown

    public static final int bestRowUnknown

  Indicates that the best row identifier may or may not be a pseudo column. A possible value for the column `PSEUDO_COLUMN` in the `ResultSet` object returned by the method `getBestRowIdentifier`.

### bestRowNotPseudo

    public static final int bestRowNotPseudo

  Indicates that the best row identifier is NOT a pseudo column. A possible value for the column `PSEUDO_COLUMN` in the `ResultSet` object returned by the method `getBestRowIdentifier`.

### bestRowPseudo

    public static final int bestRowPseudo

  Indicates that the best row identifier is a pseudo column. A possible value for the column `PSEUDO_COLUMN` in the `ResultSet` object returned by the method `getBestRowIdentifier`.

### versionColumnUnknown

    public static final int versionColumnUnknown

  Indicates that this version column may or may not be a pseudo column. A possible value for the column `PSEUDO_COLUMN` in the `ResultSet` object returned by the method `getVersionColumns`.

### versionColumnNotPseudo

    public static final int versionColumnNotPseudo

  Indicates that this version column is NOT a pseudo column. A possible value for the column `PSEUDO_COLUMN` in the `ResultSet` object returned by the method `getVersionColumns`.

### versionColumnPseudo

    public static final int versionColumnPseudo

  Indicates that this version column is a pseudo column. A possible value for the column `PSEUDO_COLUMN` in the `ResultSet` object returned by the method `getVersionColumns`.

### importedKeyCascade

    public static final int importedKeyCascade

  A possible value for the columns `UPDATE_RULE` and `DELETE_RULE` in the `ResultSet` objects returned by the methods `getImportedKeys`, `getExportedKeys`, and `getCrossReference`.

  For the column `UPDATE_RULE`, it indicates that when the primary key is updated, the foreign key (imported key) is changed to agree with it.

  For the column `DELETE_RULE`, it indicates that when the primary key is deleted, rows that imported that key are deleted.

### importedKeyRestrict

    public static final int importedKeyRestrict

  A possible value for the columns `UPDATE_RULE` and `DELETE_RULE` in the `ResultSet` objects returned by the methods `getImportedKeys`, `getExportedKeys`, and `getCrossReference`.

  For the column `UPDATE_RULE`, it indicates that a primary key may not be updated if it has been imported by another table as a foreign key.

  For the column `DELETE_RULE`, it indicates that a primary key may not be deleted if it has been imported by another table as a foreign key.

### importedKeySetNull

    public static final int importedKeySetNull

  A possible value for the columns `UPDATE_RULE` and `DELETE_RULE` in the `ResultSet` objects returned by the methods `getImportedKeys`, `getExportedKeys`, and `getCrossReference`.

  For the columns `UPDATE_RULE` and `DELETE_RULE`, it indicates that when the primary key is updated or deleted, the foreign key (imported key) is changed to `NULL`.

### importedKeyNoAction

    public static final int importedKeyNoAction

  A possible value for the columns `UPDATE_RULE` and `DELETE_RULE` in the `ResultSet` objects returned by the methods `getImportedKeys`, `getExportedKeys`, and `getCrossReference`.

  For the columns `UPDATE_RULE` and `DELETE_RULE`, it indicates that if the primary key has been imported, it cannot be updated or deleted.

### importedKeySetDefault

    public static final int importedKeySetDefault

  A possible value for the columns `UPDATE_RULE` and `DELETE_RULE` in the `ResultSet` objects returned by the methods `getImportedKeys`, `getExportedKeys`, and `getCrossReference`.

  For the columns `UPDATE_RULE` and `DELETE_RULE`, it indicates that if the primary key is updated or deleted, the foreign key (imported key) is set to the default value.

### importedKeyInitiallyDeferred

    public static final int importedKeyInitiallyDeferred

  A possible value for the column `DEFERRABILITY` in the `ResultSet` objects returned by the methods `getImportedKeys`, `getExportedKeys`, and `getCrossReference`.

  Indicates deferrability. See SQL-92 for a definition.

### importedKeyInitiallyImmediate

    public static final int importedKeyInitiallyImmediate

  A possible value for the column `DEFERRABILITY` in the `ResultSet` objects returned by the methods `getImportedKeys`, `getExportedKeys`, and `getCrossReference`.

  Indicates deferrability. See SQL-92 for a definition.

### importedKeyNotDeferrable

    public static final int importedKeyNotDeferrable

  A possible value for the column `DEFERRABILITY` in the `ResultSet` objects returned by the methods `getImportedKeys`, `getExportedKeys`, and `getCrossReference`.

  Indicates deferrability. See SQL-92 for a definition.

### typeNoNulls

    public static final int typeNoNulls

  A possible value for column `NULLABLE` in the `ResultSet` object returned by the method `getTypeInfo`.

  Indicates that a `NULL` value is NOT allowed for this data type.

### typeNullable

    public static final int typeNullable

  A possible value for column `NULLABLE` in the `ResultSet` object returned by the method `getTypeInfo`.

  Indicates that a `NULL` value is allowed for this data type.

### typeNullableUnknown

    public static final int typeNullableUnknown

  A possible value for column `NULLABLE` in the `ResultSet` object returned by the method `getTypeInfo`.

  Indicates that it is not known whether a `NULL` value is allowed for this data type.

### typePredNone

    public static final int typePredNone

  A possible value for column `SEARCHABLE` in the `ResultSet` object returned by the method `getTypeInfo`.

  Indicates that `WHERE` search clauses are not supported for this type.

### typePredChar

    public static final int typePredChar

  A possible value for column `SEARCHABLE` in the `ResultSet` object returned by the method `getTypeInfo`.

  Indicates that the only `WHERE` search clause that can be based on this type is `WHERE . . .LIKE`.

### typePredBasic

    public static final int typePredBasic

  A possible value for column `SEARCHABLE` in the `ResultSet` object returned by the method `getTypeInfo`.

  Indicates that one can base all `WHERE` search clauses except `WHERE . . .LIKE` on this data type.

### typeSearchable

    public static final int typeSearchable

  A possible value for column `SEARCHABLE` in the `ResultSet` object returned by the method `getTypeInfo`.

  Indicates that all `WHERE` search clauses can be based on this type.

### tableIndexStatistic

    public static final short tableIndexStatistic

  A possible value for column `TYPE` in the `ResultSet` object returned by the method `getIndexInfo`.

  Indicates that this column contains table statistics that are returned in conjunction with a table's index descriptions.

### tableIndexClustered

    public static final short tableIndexClustered

  A possible value for column `TYPE` in the `ResultSet` object returned by the method `getIndexInfo`.

  Indicates that this table index is a clustered index.

### tableIndexHashed

    public static final short tableIndexHashed

  A possible value for column `TYPE` in the `ResultSet` object returned by the method `getIndexInfo`.

  Indicates that this table index is a hashed index.

### tableIndexOther

    public static final short tableIndexOther

  A possible value for column `TYPE` in the `ResultSet` object returned by the method `getIndexInfo`.

  Indicates that this table index is not a clustered index, a hashed index, or table statistics; it is something other than these.

Method Detail

### allProceduresAreCallable

    public boolean allProceduresAreCallable()
                                     throws SQLException

  Can all the procedures returned by getProcedures be called by the current user?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### allTablesAreSelectable

    public boolean allTablesAreSelectable()
                                   throws SQLException

  Can all the tables returned by getTable be SELECTed by the current user?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### getURL

    public String getURL()
                  throws SQLException

  What's the url for this database?
  Returns:
    the url or null if it cannot be generated
  Throws:
    `SQLException` - if a database access error occurs

### getUserName

    public String getUserName()
                       throws SQLException

  What's our user name as known to the database?
  Returns:
    our database user name
  Throws:
    `SQLException` - if a database access error occurs

### isReadOnly

    public boolean isReadOnly()
                       throws SQLException

  Is the database in read-only mode?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### nullsAreSortedHigh

    public boolean nullsAreSortedHigh()
                               throws SQLException

  Are NULL values sorted high?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### nullsAreSortedLow

    public boolean nullsAreSortedLow()
                              throws SQLException

  Are NULL values sorted low?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### nullsAreSortedAtStart

    public boolean nullsAreSortedAtStart()
                                  throws SQLException

  Are NULL values sorted at the start regardless of sort order?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### nullsAreSortedAtEnd

    public boolean nullsAreSortedAtEnd()
                                throws SQLException

  Are NULL values sorted at the end regardless of sort order?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### getDatabaseProductName

    public String getDatabaseProductName()
                                  throws SQLException

  What's the name of this database product?
  Returns:
    database product name
  Throws:
    `SQLException` - if a database access error occurs

### getDatabaseProductVersion

    public String getDatabaseProductVersion()
                                     throws SQLException

  What's the version of this database product?
  Returns:
    database version
  Throws:
    `SQLException` - if a database access error occurs

### getDriverName

    public String getDriverName()
                         throws SQLException

  What's the name of this JDBC driver?
  Returns:
    JDBC driver name
  Throws:
    `SQLException` - if a database access error occurs

### getDriverVersion

    public String getDriverVersion()
                            throws SQLException

  What's the version of this JDBC driver?
  Returns:
    JDBC driver version
  Throws:
    `SQLException` - if a database access error occurs

### getDriverMajorVersion

    public int getDriverMajorVersion()

  What's this JDBC driver's major version number?
  Returns:
    JDBC driver major version

### getDriverMinorVersion

    public int getDriverMinorVersion()

  What's this JDBC driver's minor version number?
  Returns:
    JDBC driver minor version number

### usesLocalFiles

    public boolean usesLocalFiles()
                           throws SQLException

  Does the database store tables in a local file?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### usesLocalFilePerTable

    public boolean usesLocalFilePerTable()
                                  throws SQLException

  Does the database use a file for each table?
  Returns:
    true if the database uses a local file for each table
  Throws:
    `SQLException` - if a database access error occurs

### supportsMixedCaseIdentifiers

    public boolean supportsMixedCaseIdentifiers()
                                         throws SQLException

  Does the database treat mixed case unquoted SQL identifiers as case sensitive and as a result store them in mixed case? A JDBC CompliantTM driver will always return false.
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### storesUpperCaseIdentifiers

    public boolean storesUpperCaseIdentifiers()
                                       throws SQLException

  Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in upper case?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### storesLowerCaseIdentifiers

    public boolean storesLowerCaseIdentifiers()
                                       throws SQLException

  Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in lower case?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### storesMixedCaseIdentifiers

    public boolean storesMixedCaseIdentifiers()
                                       throws SQLException

  Does the database treat mixed case unquoted SQL identifiers as case insensitive and store them in mixed case?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsMixedCaseQuotedIdentifiers

    public boolean supportsMixedCaseQuotedIdentifiers()
                                               throws SQLException

  Does the database treat mixed case quoted SQL identifiers as case sensitive and as a result store them in mixed case? A JDBC CompliantTM driver will always return true.
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### storesUpperCaseQuotedIdentifiers

    public boolean storesUpperCaseQuotedIdentifiers()
                                             throws SQLException

  Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in upper case?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### storesLowerCaseQuotedIdentifiers

    public boolean storesLowerCaseQuotedIdentifiers()
                                             throws SQLException

  Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in lower case?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### storesMixedCaseQuotedIdentifiers

    public boolean storesMixedCaseQuotedIdentifiers()
                                             throws SQLException

  Does the database treat mixed case quoted SQL identifiers as case insensitive and store them in mixed case?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### getIdentifierQuoteString

    public String getIdentifierQuoteString()
                                    throws SQLException

  What's the string used to quote SQL identifiers? This returns a space " " if identifier quoting isn't supported. A JDBC CompliantTM driver always uses a double quote character.
  Returns:
    the quoting string
  Throws:
    `SQLException` - if a database access error occurs

### getSQLKeywords

    public String getSQLKeywords()
                          throws SQLException

  Gets a comma-separated list of all a database's SQL keywords that are NOT also SQL92 keywords.
  Returns:
    the list
  Throws:
    `SQLException` - if a database access error occurs

### getNumericFunctions

    public String getNumericFunctions()
                               throws SQLException

  Gets a comma-separated list of math functions. These are the X/Open CLI math function names used in the JDBC function escape clause.
  Returns:
    the list
  Throws:
    `SQLException` - if a database access error occurs

### getStringFunctions

    public String getStringFunctions()
                              throws SQLException

  Gets a comma-separated list of string functions. These are the X/Open CLI string function names used in the JDBC function escape clause.
  Returns:
    the list
  Throws:
    `SQLException` - if a database access error occurs

### getSystemFunctions

    public String getSystemFunctions()
                              throws SQLException

  Gets a comma-separated list of system functions. These are the X/Open CLI system function names used in the JDBC function escape clause.
  Returns:
    the list
  Throws:
    `SQLException` - if a database access error occurs

### getTimeDateFunctions

    public String getTimeDateFunctions()
                                throws SQLException

  Gets a comma-separated list of time and date functions.
  Returns:
    the list
  Throws:
    `SQLException` - if a database access error occurs

### getSearchStringEscape

    public String getSearchStringEscape()
                                 throws SQLException

  Gets the string that can be used to escape wildcard characters. This is the string that can be used to escape '_' or '%' in the string pattern style catalog search parameters.

  The '_' character represents any single character.

  The '%' character represents any sequence of zero or more characters.

  Returns:
    the string used to escape wildcard characters
  Throws:
    `SQLException` - if a database access error occurs

### getExtraNameCharacters

    public String getExtraNameCharacters()
                                  throws SQLException

  Gets all the "extra" characters that can be used in unquoted identifier names (those beyond a-z, A-Z, 0-9 and _).
  Returns:
    the string containing the extra characters
  Throws:
    `SQLException` - if a database access error occurs

### supportsAlterTableWithAddColumn

    public boolean supportsAlterTableWithAddColumn()
                                            throws SQLException

  Is "ALTER TABLE" with add column supported?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsAlterTableWithDropColumn

    public boolean supportsAlterTableWithDropColumn()
                                             throws SQLException

  Is "ALTER TABLE" with drop column supported?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsColumnAliasing

    public boolean supportsColumnAliasing()
                                   throws SQLException

  Is column aliasing supported?

  If so, the SQL AS clause can be used to provide names for computed columns or to provide alias names for columns as required. A JDBC CompliantTM driver always returns true.

  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### nullPlusNonNullIsNull

    public boolean nullPlusNonNullIsNull()
                                  throws SQLException

  Are concatenations between NULL and non-NULL values NULL? For SQL-92 compliance, a JDBC technology-enabled driver will return `true`.
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsConvert

    public boolean supportsConvert()
                            throws SQLException

  Is the CONVERT function between SQL types supported?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsConvert

    public boolean supportsConvert(int fromType,
                                   int toType)
                            throws SQLException

  Is CONVERT between the given SQL types supported?
  Parameters:
    `fromType` - the type to convert from
    `toType` - the type to convert to
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `Types`

### supportsTableCorrelationNames

    public boolean supportsTableCorrelationNames()
                                          throws SQLException

  Are table correlation names supported? A JDBC CompliantTM driver always returns true.
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsDifferentTableCorrelationNames

    public boolean supportsDifferentTableCorrelationNames()
                                                   throws SQLException

  If table correlation names are supported, are they restricted to be different from the names of the tables?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsExpressionsInOrderBy

    public boolean supportsExpressionsInOrderBy()
                                         throws SQLException

  Are expressions in "ORDER BY" lists supported?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsOrderByUnrelated

    public boolean supportsOrderByUnrelated()
                                     throws SQLException

  Can an "ORDER BY" clause use columns not in the SELECT statement?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsGroupBy

    public boolean supportsGroupBy()
                            throws SQLException

  Is some form of "GROUP BY" clause supported?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsGroupByUnrelated

    public boolean supportsGroupByUnrelated()
                                     throws SQLException

  Can a "GROUP BY" clause use columns not in the SELECT?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsGroupByBeyondSelect

    public boolean supportsGroupByBeyondSelect()
                                        throws SQLException

  Can a "GROUP BY" clause add columns not in the SELECT provided it specifies all the columns in the SELECT?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsLikeEscapeClause

    public boolean supportsLikeEscapeClause()
                                     throws SQLException

  Is the escape character in "LIKE" clauses supported? A JDBC CompliantTM driver always returns true.
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsMultipleResultSets

    public boolean supportsMultipleResultSets()
                                       throws SQLException

  Are multiple `ResultSet` from a single execute supported?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsMultipleTransactions

    public boolean supportsMultipleTransactions()
                                         throws SQLException

  Can we have multiple transactions open at once (on different connections)?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsNonNullableColumns

    public boolean supportsNonNullableColumns()
                                       throws SQLException

  Can columns be defined as non-nullable? A JDBC CompliantTM driver always returns true.
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsMinimumSQLGrammar

    public boolean supportsMinimumSQLGrammar()
                                      throws SQLException

  Is the ODBC Minimum SQL grammar supported? All JDBC CompliantTM drivers must return true.
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsCoreSQLGrammar

    public boolean supportsCoreSQLGrammar()
                                   throws SQLException

  Is the ODBC Core SQL grammar supported?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsExtendedSQLGrammar

    public boolean supportsExtendedSQLGrammar()
                                       throws SQLException

  Is the ODBC Extended SQL grammar supported?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsANSI92EntryLevelSQL

    public boolean supportsANSI92EntryLevelSQL()
                                        throws SQLException

  Is the ANSI92 entry level SQL grammar supported? All JDBC CompliantTM drivers must return true.
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsANSI92IntermediateSQL

    public boolean supportsANSI92IntermediateSQL()
                                          throws SQLException

  Is the ANSI92 intermediate SQL grammar supported?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsANSI92FullSQL

    public boolean supportsANSI92FullSQL()
                                  throws SQLException

  Is the ANSI92 full SQL grammar supported?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsIntegrityEnhancementFacility

    public boolean supportsIntegrityEnhancementFacility()
                                                 throws SQLException

  Is the SQL Integrity Enhancement Facility supported?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsOuterJoins

    public boolean supportsOuterJoins()
                               throws SQLException

  Is some form of outer join supported?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsFullOuterJoins

    public boolean supportsFullOuterJoins()
                                   throws SQLException

  Are full nested outer joins supported?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsLimitedOuterJoins

    public boolean supportsLimitedOuterJoins()
                                      throws SQLException

  Is there limited support for outer joins? (This will be true if supportFullOuterJoins is true.)
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### getSchemaTerm

    public String getSchemaTerm()
                         throws SQLException

  What's the database vendor's preferred term for "schema"?
  Returns:
    the vendor term
  Throws:
    `SQLException` - if a database access error occurs

### getProcedureTerm

    public String getProcedureTerm()
                            throws SQLException

  What's the database vendor's preferred term for "procedure"?
  Returns:
    the vendor term
  Throws:
    `SQLException` - if a database access error occurs

### getCatalogTerm

    public String getCatalogTerm()
                          throws SQLException

  What's the database vendor's preferred term for "catalog"?
  Returns:
    the vendor term
  Throws:
    `SQLException` - if a database access error occurs

### isCatalogAtStart

    public boolean isCatalogAtStart()
                             throws SQLException

  Does a catalog appear at the start of a qualified table name? (Otherwise it appears at the end)
  Returns:
    true if it appears at the start
  Throws:
    `SQLException` - if a database access error occurs

### getCatalogSeparator

    public String getCatalogSeparator()
                               throws SQLException

  What's the separator between catalog and table name?
  Returns:
    the separator string
  Throws:
    `SQLException` - if a database access error occurs

### supportsSchemasInDataManipulation

    public boolean supportsSchemasInDataManipulation()
                                              throws SQLException

  Can a schema name be used in a data manipulation statement?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSchemasInProcedureCalls

    public boolean supportsSchemasInProcedureCalls()
                                            throws SQLException

  Can a schema name be used in a procedure call statement?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSchemasInTableDefinitions

    public boolean supportsSchemasInTableDefinitions()
                                              throws SQLException

  Can a schema name be used in a table definition statement?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSchemasInIndexDefinitions

    public boolean supportsSchemasInIndexDefinitions()
                                              throws SQLException

  Can a schema name be used in an index definition statement?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSchemasInPrivilegeDefinitions

    public boolean supportsSchemasInPrivilegeDefinitions()
                                                  throws SQLException

  Can a schema name be used in a privilege definition statement?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsCatalogsInDataManipulation

    public boolean supportsCatalogsInDataManipulation()
                                               throws SQLException

  Can a catalog name be used in a data manipulation statement?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsCatalogsInProcedureCalls

    public boolean supportsCatalogsInProcedureCalls()
                                             throws SQLException

  Can a catalog name be used in a procedure call statement?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsCatalogsInTableDefinitions

    public boolean supportsCatalogsInTableDefinitions()
                                               throws SQLException

  Can a catalog name be used in a table definition statement?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsCatalogsInIndexDefinitions

    public boolean supportsCatalogsInIndexDefinitions()
                                               throws SQLException

  Can a catalog name be used in an index definition statement?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsCatalogsInPrivilegeDefinitions

    public boolean supportsCatalogsInPrivilegeDefinitions()
                                                   throws SQLException

  Can a catalog name be used in a privilege definition statement?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsPositionedDelete

    public boolean supportsPositionedDelete()
                                     throws SQLException

  Is positioned DELETE supported?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsPositionedUpdate

    public boolean supportsPositionedUpdate()
                                     throws SQLException

  Is positioned UPDATE supported?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSelectForUpdate

    public boolean supportsSelectForUpdate()
                                    throws SQLException

  Is SELECT for UPDATE supported?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsStoredProcedures

    public boolean supportsStoredProcedures()
                                     throws SQLException

  Are stored procedure calls using the stored procedure escape syntax supported?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSubqueriesInComparisons

    public boolean supportsSubqueriesInComparisons()
                                            throws SQLException

  Are subqueries in comparison expressions supported? A JDBC CompliantTM driver always returns true.
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSubqueriesInExists

    public boolean supportsSubqueriesInExists()
                                       throws SQLException

  Are subqueries in 'exists' expressions supported? A JDBC CompliantTM driver always returns true.
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSubqueriesInIns

    public boolean supportsSubqueriesInIns()
                                    throws SQLException

  Are subqueries in 'in' statements supported? A JDBC CompliantTM driver always returns true.
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsSubqueriesInQuantifieds

    public boolean supportsSubqueriesInQuantifieds()
                                            throws SQLException

  Are subqueries in quantified expressions supported? A JDBC CompliantTM driver always returns true.
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsCorrelatedSubqueries

    public boolean supportsCorrelatedSubqueries()
                                         throws SQLException

  Are correlated subqueries supported? A JDBC CompliantTM driver always returns true.
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsUnion

    public boolean supportsUnion()
                          throws SQLException

  Is SQL UNION supported?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsUnionAll

    public boolean supportsUnionAll()
                             throws SQLException

  Is SQL UNION ALL supported?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsOpenCursorsAcrossCommit

    public boolean supportsOpenCursorsAcrossCommit()
                                            throws SQLException

  Can cursors remain open across commits?
  Returns:
    `true` if cursors always remain open; `false` if they might not remain open
  Throws:
    `SQLException` - if a database access error occurs

### supportsOpenCursorsAcrossRollback

    public boolean supportsOpenCursorsAcrossRollback()
                                              throws SQLException

  Can cursors remain open across rollbacks?
  Returns:
    `true` if cursors always remain open; `false` if they might not remain open
  Throws:
    `SQLException` - if a database access error occurs

### supportsOpenStatementsAcrossCommit

    public boolean supportsOpenStatementsAcrossCommit()
                                               throws SQLException

  Can statements remain open across commits?
  Returns:
    `true` if statements always remain open; `false` if they might not remain open
  Throws:
    `SQLException` - if a database access error occurs

### supportsOpenStatementsAcrossRollback

    public boolean supportsOpenStatementsAcrossRollback()
                                                 throws SQLException

  Can statements remain open across rollbacks?
  Returns:
    `true` if statements always remain open; `false` if they might not remain open
  Throws:
    `SQLException` - if a database access error occurs

### getMaxBinaryLiteralLength

    public int getMaxBinaryLiteralLength()
                                  throws SQLException

  How many hex characters can you have in an inline binary literal?
  Returns:
    max binary literal length in hex characters; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxCharLiteralLength

    public int getMaxCharLiteralLength()
                                throws SQLException

  What's the max length for a character literal?
  Returns:
    max literal length; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxColumnNameLength

    public int getMaxColumnNameLength()
                               throws SQLException

  What's the limit on column name length?
  Returns:
    max column name length; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxColumnsInGroupBy

    public int getMaxColumnsInGroupBy()
                               throws SQLException

  What's the maximum number of columns in a "GROUP BY" clause?
  Returns:
    max number of columns; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxColumnsInIndex

    public int getMaxColumnsInIndex()
                             throws SQLException

  What's the maximum number of columns allowed in an index?
  Returns:
    max number of columns; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxColumnsInOrderBy

    public int getMaxColumnsInOrderBy()
                               throws SQLException

  What's the maximum number of columns in an "ORDER BY" clause?
  Returns:
    max number of columns; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxColumnsInSelect

    public int getMaxColumnsInSelect()
                              throws SQLException

  What's the maximum number of columns in a "SELECT" list?
  Returns:
    max number of columns; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxColumnsInTable

    public int getMaxColumnsInTable()
                             throws SQLException

  What's the maximum number of columns in a table?
  Returns:
    max number of columns; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxConnections

    public int getMaxConnections()
                          throws SQLException

  How many active connections can we have at a time to this database?
  Returns:
    max number of active connections; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxCursorNameLength

    public int getMaxCursorNameLength()
                               throws SQLException

  What's the maximum cursor name length?
  Returns:
    max cursor name length in bytes; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxIndexLength

    public int getMaxIndexLength()
                          throws SQLException

  Retrieves the maximum number of bytes for an index, including all of the parts of the index.
  Returns:
    max index length in bytes, which includes the composite of all the constituent parts of the index; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxSchemaNameLength

    public int getMaxSchemaNameLength()
                               throws SQLException

  What's the maximum length allowed for a schema name?
  Returns:
    max name length in bytes; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxProcedureNameLength

    public int getMaxProcedureNameLength()
                                  throws SQLException

  What's the maximum length of a procedure name?
  Returns:
    max name length in bytes; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxCatalogNameLength

    public int getMaxCatalogNameLength()
                                throws SQLException

  What's the maximum length of a catalog name?
  Returns:
    max name length in bytes; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxRowSize

    public int getMaxRowSize()
                      throws SQLException

  What's the maximum length of a single row?
  Returns:
    max row size in bytes; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### doesMaxRowSizeIncludeBlobs

    public boolean doesMaxRowSizeIncludeBlobs()
                                       throws SQLException

  Did getMaxRowSize() include LONGVARCHAR and LONGVARBINARY blobs?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### getMaxStatementLength

    public int getMaxStatementLength()
                              throws SQLException

  What's the maximum length of an SQL statement?
  Returns:
    max length in bytes; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxStatements

    public int getMaxStatements()
                         throws SQLException

  How many active statements can we have open at one time to this database?
  Returns:
    the maximum number of statements that can be open at one time; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxTableNameLength

    public int getMaxTableNameLength()
                              throws SQLException

  What's the maximum length of a table name?
  Returns:
    max name length in bytes; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxTablesInSelect

    public int getMaxTablesInSelect()
                             throws SQLException

  What's the maximum number of tables in a SELECT statement?
  Returns:
    the maximum number of tables allowed in a SELECT statement; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getMaxUserNameLength

    public int getMaxUserNameLength()
                             throws SQLException

  What's the maximum length of a user name?
  Returns:
    max user name length in bytes; a result of zero means that there is no limit or the limit is not known
  Throws:
    `SQLException` - if a database access error occurs

### getDefaultTransactionIsolation

    public int getDefaultTransactionIsolation()
                                       throws SQLException

  What's the database's default transaction isolation level? The values are defined in `java.sql.Connection`.
  Returns:
    the default isolation level
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `Connection`

### supportsTransactions

    public boolean supportsTransactions()
                                 throws SQLException

  Are transactions supported? If not, invoking the method `commit` is a noop and the isolation level is TRANSACTION_NONE.
  Returns:
    `true` if transactions are supported; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsTransactionIsolationLevel

    public boolean supportsTransactionIsolationLevel(int level)
                                              throws SQLException

  Does this database support the given transaction isolation level?
  Parameters:
    `level` - the values are defined in `java.sql.Connection`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `Connection`

### supportsDataDefinitionAndDataManipulationTransactions

    public boolean supportsDataDefinitionAndDataManipulationTransactions()
                                                                  throws SQLException

  Are both data definition and data manipulation statements within a transaction supported?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### supportsDataManipulationTransactionsOnly

    public boolean supportsDataManipulationTransactionsOnly()
                                                     throws SQLException

  Are only data manipulation statements within a transaction supported?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### dataDefinitionCausesTransactionCommit

    public boolean dataDefinitionCausesTransactionCommit()
                                                  throws SQLException

  Does a data definition statement within a transaction force the transaction to commit?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### dataDefinitionIgnoredInTransactions

    public boolean dataDefinitionIgnoredInTransactions()
                                                throws SQLException

  Is a data definition statement within a transaction ignored?
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs

### getProcedures

    public ResultSet getProcedures(String catalog,
                                   String schemaPattern,
                                   String procedureNamePattern)
                            throws SQLException

  Gets a description of the stored procedures available in a catalog.

  Only procedure descriptions matching the schema and procedure name criteria are returned. They are ordered by PROCEDURE_SCHEM, and PROCEDURE_NAME.

  Each procedure description has the the following columns:

  1. PROCEDURE_CAT String => procedure catalog (may be null)
  2. PROCEDURE_SCHEM String => procedure schema (may be null)
  3. PROCEDURE_NAME String => procedure name
  4. reserved for future use
  5. reserved for future use
  6. reserved for future use
  7. REMARKS String => explanatory comment on the procedure
  8. PROCEDURE_TYPE short => kind of procedure:
     - procedureResultUnknown - May return a result
     - procedureNoResult - Does not return a result
     - procedureReturnsResult - Returns a result
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `procedureNamePattern` - a procedure name pattern
  Returns:
    `ResultSet` - each row is a procedure description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getProcedureColumns

    public ResultSet getProcedureColumns(String catalog,
                                         String schemaPattern,
                                         String procedureNamePattern,
                                         String columnNamePattern)
                                  throws SQLException

  Gets a description of a catalog's stored procedure parameters and result columns.

  Only descriptions matching the schema, procedure and parameter name criteria are returned. They are ordered by PROCEDURE_SCHEM and PROCEDURE_NAME. Within this, the return value, if any, is first. Next are the parameter descriptions in call order. The column descriptions follow in column number order.

  Each row in the `ResultSet` is a parameter description or column description with the following fields:

  1. PROCEDURE_CAT String => procedure catalog (may be null)
  2. PROCEDURE_SCHEM String => procedure schema (may be null)
  3. PROCEDURE_NAME String => procedure name
  4. COLUMN_NAME String => column/parameter name
  5. COLUMN_TYPE Short => kind of column/parameter:
     - procedureColumnUnknown - nobody knows
     - procedureColumnIn - IN parameter
     - procedureColumnInOut - INOUT parameter
     - procedureColumnOut - OUT parameter
     - procedureColumnReturn - procedure return value
     - procedureColumnResult - result column in `ResultSet`
  6. DATA_TYPE short => SQL type from java.sql.Types
  7. TYPE_NAME String => SQL type name, for a UDT type the type name is fully qualified
  8. PRECISION int => precision
  9. LENGTH int => length in bytes of data
  10. SCALE short => scale
  11. RADIX short => radix
  12. NULLABLE short => can it contain NULL?
      - procedureNoNulls - does not allow NULL values
      - procedureNullable - allows NULL values
      - procedureNullableUnknown - nullability unknown
  13. REMARKS String => comment describing parameter/column

  Note: Some databases may not return the column descriptions for a procedure. Additional columns beyond REMARKS can be defined by the database.

  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `procedureNamePattern` - a procedure name pattern
    `columnNamePattern` - a column name pattern
  Returns:
    `ResultSet` - each row describes a stored procedure parameter or column
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getTables

    public ResultSet getTables(String catalog,
                               String schemaPattern,
                               String tableNamePattern,
                               String[] types)
                        throws SQLException

  Gets a description of tables available in a catalog.

  Only table descriptions matching the catalog, schema, table name and type criteria are returned. They are ordered by TABLE_TYPE, TABLE_SCHEM and TABLE_NAME.

  Each table description has the following columns:

  1. TABLE_CAT String => table catalog (may be null)
  2. TABLE_SCHEM String => table schema (may be null)
  3. TABLE_NAME String => table name
  4. TABLE_TYPE String => table type. Typical types are "TABLE", "VIEW", "SYSTEM TABLE", "GLOBAL TEMPORARY", "LOCAL TEMPORARY", "ALIAS", "SYNONYM".
  5. REMARKS String => explanatory comment on the table

  Note: Some databases may not return information for all tables.

  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `tableNamePattern` - a table name pattern
    `types` - a list of table types to include; null returns all types
  Returns:
    `ResultSet` - each row is a table description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getSchemas

    public ResultSet getSchemas()
                         throws SQLException

  Gets the schema names available in this database. The results are ordered by schema name.

  The schema column is:

  1. TABLE_SCHEM String => schema name
  Returns:
    `ResultSet` - each row has a single String column that is a schema name
  Throws:
    `SQLException` - if a database access error occurs

### getCatalogs

    public ResultSet getCatalogs()
                          throws SQLException

  Gets the catalog names available in this database. The results are ordered by catalog name.

  The catalog column is:

  1. TABLE_CAT String => catalog name
  Returns:
    `ResultSet` - each row has a single String column that is a catalog name
  Throws:
    `SQLException` - if a database access error occurs

### getTableTypes

    public ResultSet getTableTypes()
                            throws SQLException

  Gets the table types available in this database. The results are ordered by table type.

  The table type is:

  1. TABLE_TYPE String => table type. Typical types are "TABLE", "VIEW", "SYSTEM TABLE", "GLOBAL TEMPORARY", "LOCAL TEMPORARY", "ALIAS", "SYNONYM".
  Returns:
    `ResultSet` - each row has a single String column that is a table type
  Throws:
    `SQLException` - if a database access error occurs

### getColumns

    public ResultSet getColumns(String catalog,
                                String schemaPattern,
                                String tableNamePattern,
                                String columnNamePattern)
                         throws SQLException

  Gets a description of table columns available in the specified catalog.

  Only column descriptions matching the catalog, schema, table and column name criteria are returned. They are ordered by TABLE_SCHEM, TABLE_NAME and ORDINAL_POSITION.

  Each column description has the following columns:

  1. TABLE_CAT String => table catalog (may be null)
  2. TABLE_SCHEM String => table schema (may be null)
  3. TABLE_NAME String => table name
  4. COLUMN_NAME String => column name
  5. DATA_TYPE short => SQL type from java.sql.Types
  6. TYPE_NAME String => Data source dependent type name, for a UDT the type name is fully qualified
  7. COLUMN_SIZE int => column size. For char or date types this is the maximum number of characters, for numeric or decimal types this is precision.
  8. BUFFER_LENGTH is not used.
  9. DECIMAL_DIGITS int => the number of fractional digits
  10. NUM_PREC_RADIX int => Radix (typically either 10 or 2)
  11. NULLABLE int => is NULL allowed?
      - columnNoNulls - might not allow NULL values
      - columnNullable - definitely allows NULL values
      - columnNullableUnknown - nullability unknown
  12. REMARKS String => comment describing column (may be null)
  13. COLUMN_DEF String => default value (may be null)
  14. SQL_DATA_TYPE int => unused
  15. SQL_DATETIME_SUB int => unused
  16. CHAR_OCTET_LENGTH int => for char types the maximum number of bytes in the column
  17. ORDINAL_POSITION int => index of column in table (starting at 1)
  18. IS_NULLABLE String => "NO" means column definitely does not allow NULL values; "YES" means the column might allow NULL values. An empty string means nobody knows.
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `tableNamePattern` - a table name pattern
    `columnNamePattern` - a column name pattern
  Returns:
    `ResultSet` - each row is a column description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getColumnPrivileges

    public ResultSet getColumnPrivileges(String catalog,
                                         String schema,
                                         String table,
                                         String columnNamePattern)
                                  throws SQLException

  Gets a description of the access rights for a table's columns.

  Only privileges matching the column name criteria are returned. They are ordered by COLUMN_NAME and PRIVILEGE.

  Each privilige description has the following columns:

  1. TABLE_CAT String => table catalog (may be null)
  2. TABLE_SCHEM String => table schema (may be null)
  3. TABLE_NAME String => table name
  4. COLUMN_NAME String => column name
  5. GRANTOR => grantor of access (may be null)
  6. GRANTEE String => grantee of access
  7. PRIVILEGE String => name of access (SELECT, INSERT, UPDATE, REFRENCES, ...)
  8. IS_GRANTABLE String => "YES" if grantee is permitted to grant to others; "NO" if not; null if unknown
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
    `columnNamePattern` - a column name pattern
  Returns:
    `ResultSet` - each row is a column privilege description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getTablePrivileges

    public ResultSet getTablePrivileges(String catalog,
                                        String schemaPattern,
                                        String tableNamePattern)
                                 throws SQLException

  Gets a description of the access rights for each table available in a catalog. Note that a table privilege applies to one or more columns in the table. It would be wrong to assume that this priviledge applies to all columns (this may be true for some systems but is not true for all.)

  Only privileges matching the schema and table name criteria are returned. They are ordered by TABLE_SCHEM, TABLE_NAME, and PRIVILEGE.

  Each privilige description has the following columns:

  1. TABLE_CAT String => table catalog (may be null)
  2. TABLE_SCHEM String => table schema (may be null)
  3. TABLE_NAME String => table name
  4. GRANTOR => grantor of access (may be null)
  5. GRANTEE String => grantee of access
  6. PRIVILEGE String => name of access (SELECT, INSERT, UPDATE, REFRENCES, ...)
  7. IS_GRANTABLE String => "YES" if grantee is permitted to grant to others; "NO" if not; null if unknown
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `tableNamePattern` - a table name pattern
  Returns:
    `ResultSet` - each row is a table privilege description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getSearchStringEscape()`

### getBestRowIdentifier

    public ResultSet getBestRowIdentifier(String catalog,
                                          String schema,
                                          String table,
                                          int scope,
                                          boolean nullable)
                                   throws SQLException

  Gets a description of a table's optimal set of columns that uniquely identifies a row. They are ordered by SCOPE.

  Each column description has the following columns:

  1. SCOPE short => actual scope of result
     - bestRowTemporary - very temporary, while using row
     - bestRowTransaction - valid for remainder of current transaction
     - bestRowSession - valid for remainder of current session
  2. COLUMN_NAME String => column name
  3. DATA_TYPE short => SQL data type from java.sql.Types
  4. TYPE_NAME String => Data source dependent type name, for a UDT the type name is fully qualified
  5. COLUMN_SIZE int => precision
  6. BUFFER_LENGTH int => not used
  7. DECIMAL_DIGITS short => scale
  8. PSEUDO_COLUMN short => is this a pseudo column like an Oracle ROWID
     - bestRowUnknown - may or may not be pseudo column
     - bestRowNotPseudo - is NOT a pseudo column
     - bestRowPseudo - is a pseudo column
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
    `scope` - the scope of interest; use same values as SCOPE
    `nullable` - include columns that are nullable?
  Returns:
    `ResultSet` - each row is a column description
  Throws:
    `SQLException` - if a database access error occurs

### getVersionColumns

    public ResultSet getVersionColumns(String catalog,
                                       String schema,
                                       String table)
                                throws SQLException

  Gets a description of a table's columns that are automatically updated when any value in a row is updated. They are unordered.

  Each column description has the following columns:

  1. SCOPE short => is not used
  2. COLUMN_NAME String => column name
  3. DATA_TYPE short => SQL data type from java.sql.Types
  4. TYPE_NAME String => Data source dependent type name
  5. COLUMN_SIZE int => precision
  6. BUFFER_LENGTH int => length of column value in bytes
  7. DECIMAL_DIGITS short => scale
  8. PSEUDO_COLUMN short => is this a pseudo column like an Oracle ROWID
     - versionColumnUnknown - may or may not be pseudo column
     - versionColumnNotPseudo - is NOT a pseudo column
     - versionColumnPseudo - is a pseudo column
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
  Returns:
    `ResultSet` - each row is a column description
  Throws:
    `SQLException` - if a database access error occurs

### getPrimaryKeys

    public ResultSet getPrimaryKeys(String catalog,
                                    String schema,
                                    String table)
                             throws SQLException

  Gets a description of a table's primary key columns. They are ordered by COLUMN_NAME.

  Each primary key column description has the following columns:

  1. TABLE_CAT String => table catalog (may be null)
  2. TABLE_SCHEM String => table schema (may be null)
  3. TABLE_NAME String => table name
  4. COLUMN_NAME String => column name
  5. KEY_SEQ short => sequence number within primary key
  6. PK_NAME String => primary key name (may be null)
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
  Returns:
    `ResultSet` - each row is a primary key column description
  Throws:
    `SQLException` - if a database access error occurs

### getImportedKeys

    public ResultSet getImportedKeys(String catalog,
                                     String schema,
                                     String table)
                              throws SQLException

  Gets a description of the primary key columns that are referenced by a table's foreign key columns (the primary keys imported by a table). They are ordered by PKTABLE_CAT, PKTABLE_SCHEM, PKTABLE_NAME, and KEY_SEQ.

  Each primary key column description has the following columns:

  1. PKTABLE_CAT String => primary key table catalog being imported (may be null)
  2. PKTABLE_SCHEM String => primary key table schema being imported (may be null)
  3. PKTABLE_NAME String => primary key table name being imported
  4. PKCOLUMN_NAME String => primary key column name being imported
  5. FKTABLE_CAT String => foreign key table catalog (may be null)
  6. FKTABLE_SCHEM String => foreign key table schema (may be null)
  7. FKTABLE_NAME String => foreign key table name
  8. FKCOLUMN_NAME String => foreign key column name
  9. KEY_SEQ short => sequence number within foreign key
  10. UPDATE_RULE short => What happens to foreign key when primary is updated:
      - importedNoAction - do not allow update of primary key if it has been imported
      - importedKeyCascade - change imported key to agree with primary key update
      - importedKeySetNull - change imported key to NULL if its primary key has been updated
      - importedKeySetDefault - change imported key to default values if its primary key has been updated
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
  11. DELETE_RULE short => What happens to the foreign key when primary is deleted.
      - importedKeyNoAction - do not allow delete of primary key if it has been imported
      - importedKeyCascade - delete rows that import a deleted key
      - importedKeySetNull - change imported key to NULL if its primary key has been deleted
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
      - importedKeySetDefault - change imported key to default if its primary key has been deleted
  12. FK_NAME String => foreign key name (may be null)
  13. PK_NAME String => primary key name (may be null)
  14. DEFERRABILITY short => can the evaluation of foreign key constraints be deferred until commit
      - importedKeyInitiallyDeferred - see SQL92 for definition
      - importedKeyInitiallyImmediate - see SQL92 for definition
      - importedKeyNotDeferrable - see SQL92 for definition
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
  Returns:
    `ResultSet` - each row is a primary key column description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getExportedKeys(java.lang.String, java.lang.String, java.lang.String)`

### getExportedKeys

    public ResultSet getExportedKeys(String catalog,
                                     String schema,
                                     String table)
                              throws SQLException

  Gets a description of the foreign key columns that reference a table's primary key columns (the foreign keys exported by a table). They are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and KEY_SEQ.

  Each foreign key column description has the following columns:

  1. PKTABLE_CAT String => primary key table catalog (may be null)
  2. PKTABLE_SCHEM String => primary key table schema (may be null)
  3. PKTABLE_NAME String => primary key table name
  4. PKCOLUMN_NAME String => primary key column name
  5. FKTABLE_CAT String => foreign key table catalog (may be null) being exported (may be null)
  6. FKTABLE_SCHEM String => foreign key table schema (may be null) being exported (may be null)
  7. FKTABLE_NAME String => foreign key table name being exported
  8. FKCOLUMN_NAME String => foreign key column name being exported
  9. KEY_SEQ short => sequence number within foreign key
  10. UPDATE_RULE short => What happens to foreign key when primary is updated:
      - importedNoAction - do not allow update of primary key if it has been imported
      - importedKeyCascade - change imported key to agree with primary key update
      - importedKeySetNull - change imported key to NULL if its primary key has been updated
      - importedKeySetDefault - change imported key to default values if its primary key has been updated
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
  11. DELETE_RULE short => What happens to the foreign key when primary is deleted.
      - importedKeyNoAction - do not allow delete of primary key if it has been imported
      - importedKeyCascade - delete rows that import a deleted key
      - importedKeySetNull - change imported key to NULL if its primary key has been deleted
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
      - importedKeySetDefault - change imported key to default if its primary key has been deleted
  12. FK_NAME String => foreign key name (may be null)
  13. PK_NAME String => primary key name (may be null)
  14. DEFERRABILITY short => can the evaluation of foreign key constraints be deferred until commit
      - importedKeyInitiallyDeferred - see SQL92 for definition
      - importedKeyInitiallyImmediate - see SQL92 for definition
      - importedKeyNotDeferrable - see SQL92 for definition
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
  Returns:
    `ResultSet` - each row is a foreign key column description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getImportedKeys(java.lang.String, java.lang.String, java.lang.String)`

### getCrossReference

    public ResultSet getCrossReference(String primaryCatalog,
                                       String primarySchema,
                                       String primaryTable,
                                       String foreignCatalog,
                                       String foreignSchema,
                                       String foreignTable)
                                throws SQLException

  Gets a description of the foreign key columns in the foreign key table that reference the primary key columns of the primary key table (describe how one table imports another's key.) This should normally return a single foreign key/primary key pair (most tables only import a foreign key from a table once.) They are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and KEY_SEQ.

  Each foreign key column description has the following columns:

  1. PKTABLE_CAT String => primary key table catalog (may be null)
  2. PKTABLE_SCHEM String => primary key table schema (may be null)
  3. PKTABLE_NAME String => primary key table name
  4. PKCOLUMN_NAME String => primary key column name
  5. FKTABLE_CAT String => foreign key table catalog (may be null) being exported (may be null)
  6. FKTABLE_SCHEM String => foreign key table schema (may be null) being exported (may be null)
  7. FKTABLE_NAME String => foreign key table name being exported
  8. FKCOLUMN_NAME String => foreign key column name being exported
  9. KEY_SEQ short => sequence number within foreign key
  10. UPDATE_RULE short => What happens to foreign key when primary is updated:
      - importedNoAction - do not allow update of primary key if it has been imported
      - importedKeyCascade - change imported key to agree with primary key update
      - importedKeySetNull - change imported key to NULL if its primary key has been updated
      - importedKeySetDefault - change imported key to default values if its primary key has been updated
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
  11. DELETE_RULE short => What happens to the foreign key when primary is deleted.
      - importedKeyNoAction - do not allow delete of primary key if it has been imported
      - importedKeyCascade - delete rows that import a deleted key
      - importedKeySetNull - change imported key to NULL if its primary key has been deleted
      - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
      - importedKeySetDefault - change imported key to default if its primary key has been deleted
  12. FK_NAME String => foreign key name (may be null)
  13. PK_NAME String => primary key name (may be null)
  14. DEFERRABILITY short => can the evaluation of foreign key constraints be deferred until commit
      - importedKeyInitiallyDeferred - see SQL92 for definition
      - importedKeyInitiallyImmediate - see SQL92 for definition
      - importedKeyNotDeferrable - see SQL92 for definition
  Parameters:
    `primaryCatalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `primarySchema` - a schema name; "" retrieves those without a schema
    `primaryTable` - the table name that exports the key
    `foreignCatalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `foreignSchema` - a schema name; "" retrieves those without a schema
    `foreignTable` - the table name that imports the key
  Returns:
    `ResultSet` - each row is a foreign key column description
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `getImportedKeys(java.lang.String, java.lang.String, java.lang.String)`

### getTypeInfo

    public ResultSet getTypeInfo()
                          throws SQLException

  Gets a description of all the standard SQL types supported by this database. They are ordered by DATA_TYPE and then by how closely the data type maps to the corresponding JDBC SQL type.

  Each type description has the following columns:

  1. TYPE_NAME String => Type name
  2. DATA_TYPE short => SQL data type from java.sql.Types
  3. PRECISION int => maximum precision
  4. LITERAL_PREFIX String => prefix used to quote a literal (may be null)
  5. LITERAL_SUFFIX String => suffix used to quote a literal (may be null)
  6. CREATE_PARAMS String => parameters used in creating the type (may be null)
  7. NULLABLE short => can you use NULL for this type?
     - typeNoNulls - does not allow NULL values
     - typeNullable - allows NULL values
     - typeNullableUnknown - nullability unknown
  8. CASE_SENSITIVE boolean=> is it case sensitive?
  9. SEARCHABLE short => can you use "WHERE" based on this type:
     - typePredNone - No support
     - typePredChar - Only supported with WHERE .. LIKE
     - typePredBasic - Supported except for WHERE .. LIKE
     - typeSearchable - Supported for all WHERE ..
  10. UNSIGNED_ATTRIBUTE boolean => is it unsigned?
  11. FIXED_PREC_SCALE boolean => can it be a money value?
  12. AUTO_INCREMENT boolean => can it be used for an auto-increment value?
  13. LOCAL_TYPE_NAME String => localized version of type name (may be null)
  14. MINIMUM_SCALE short => minimum scale supported
  15. MAXIMUM_SCALE short => maximum scale supported
  16. SQL_DATA_TYPE int => unused
  17. SQL_DATETIME_SUB int => unused
  18. NUM_PREC_RADIX int => usually 2 or 10
  Returns:
    `ResultSet` - each row is an SQL type description
  Throws:
    `SQLException` - if a database access error occurs

### getIndexInfo

    public ResultSet getIndexInfo(String catalog,
                                  String schema,
                                  String table,
                                  boolean unique,
                                  boolean approximate)
                           throws SQLException

  Gets a description of a table's indices and statistics. They are ordered by NON_UNIQUE, TYPE, INDEX_NAME, and ORDINAL_POSITION.

  Each index column description has the following columns:

  1. TABLE_CAT String => table catalog (may be null)
  2. TABLE_SCHEM String => table schema (may be null)
  3. TABLE_NAME String => table name
  4. NON_UNIQUE boolean => Can index values be non-unique? false when TYPE is tableIndexStatistic
  5. INDEX_QUALIFIER String => index catalog (may be null); null when TYPE is tableIndexStatistic
  6. INDEX_NAME String => index name; null when TYPE is tableIndexStatistic
  7. TYPE short => index type:
     - tableIndexStatistic - this identifies table statistics that are returned in conjuction with a table's index descriptions
     - tableIndexClustered - this is a clustered index
     - tableIndexHashed - this is a hashed index
     - tableIndexOther - this is some other style of index
  8. ORDINAL_POSITION short => column sequence number within index; zero when TYPE is tableIndexStatistic
  9. COLUMN_NAME String => column name; null when TYPE is tableIndexStatistic
  10. ASC_OR_DESC String => column sort sequence, "A" => ascending, "D" => descending, may be null if sort sequence is not supported; null when TYPE is tableIndexStatistic
  11. CARDINALITY int => When TYPE is tableIndexStatistic, then this is the number of rows in the table; otherwise, it is the number of unique values in the index.
  12. PAGES int => When TYPE is tableIndexStatisic then this is the number of pages used for the table, otherwise it is the number of pages used for the current index.
  13. FILTER_CONDITION String => Filter condition, if any. (may be null)
  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schema` - a schema name; "" retrieves those without a schema
    `table` - a table name
    `unique` - when true, return only indices for unique values; when false, return indices regardless of whether unique or not
    `approximate` - when true, result is allowed to reflect approximate or out of data values; when false, results are requested to be accurate
  Returns:
    `ResultSet` - each row is an index column description
  Throws:
    `SQLException` - if a database access error occurs

### supportsResultSetType

    public boolean supportsResultSetType(int type)
                                  throws SQLException

  Does the database support the given result set type?
  Parameters:
    `type` - defined in `java.sql.ResultSet`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    `Connection`, What Is in the JDBC 2.0 API

### supportsResultSetConcurrency

    public boolean supportsResultSetConcurrency(int type,
                                                int concurrency)
                                         throws SQLException

  Does the database support the concurrency type in combination with the given result set type?
  Parameters:
    `type` - defined in `java.sql.ResultSet`
    `concurrency` - type defined in `java.sql.ResultSet`
  Returns:
    `true` if so; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    `Connection`, What Is in the JDBC 2.0 API

### ownUpdatesAreVisible

    public boolean ownUpdatesAreVisible(int type)
                                 throws SQLException

  Indicates whether a result set's own updates are visible.
  Parameters:
    `result` - set type, i.e. ResultSet.TYPE_XXX
  Returns:
    `true` if updates are visible for the result set type; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### ownDeletesAreVisible

    public boolean ownDeletesAreVisible(int type)
                                 throws SQLException

  Indicates whether a result set's own deletes are visible.
  Parameters:
    `result` - set type, i.e. ResultSet.TYPE_XXX
  Returns:
    `true` if deletes are visible for the result set type; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### ownInsertsAreVisible

    public boolean ownInsertsAreVisible(int type)
                                 throws SQLException

  Indicates whether a result set's own inserts are visible.
  Parameters:
    `result` - set type, i.e. ResultSet.TYPE_XXX
  Returns:
    `true` if inserts are visible for the result set type; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### othersUpdatesAreVisible

    public boolean othersUpdatesAreVisible(int type)
                                    throws SQLException

  Indicates whether updates made by others are visible.
  Parameters:
    `result` - set type, i.e. ResultSet.TYPE_XXX
  Returns:
    `true` if updates made by others are visible for the result set type; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### othersDeletesAreVisible

    public boolean othersDeletesAreVisible(int type)
                                    throws SQLException

  Indicates whether deletes made by others are visible.
  Parameters:
    `result` - set type, i.e. ResultSet.TYPE_XXX
  Returns:
    `true` if deletes made by others are visible for the result set type; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### othersInsertsAreVisible

    public boolean othersInsertsAreVisible(int type)
                                    throws SQLException

  Indicates whether inserts made by others are visible.
  Parameters:
    `result` - set type, i.e. ResultSet.TYPE_XXX
  Returns:
    true if updates are visible for the result set type
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### updatesAreDetected

    public boolean updatesAreDetected(int type)
                               throws SQLException

  Indicates whether or not a visible row update can be detected by calling the method `ResultSet.rowUpdated`.
  Parameters:
    `result` - set type, i.e. ResultSet.TYPE_XXX
  Returns:
    `true` if changes are detected by the result set type; `false` otherwise
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### deletesAreDetected

    public boolean deletesAreDetected(int type)
                               throws SQLException

  Indicates whether or not a visible row delete can be detected by calling ResultSet.rowDeleted(). If deletesAreDetected() returns false, then deleted rows are removed from the result set.
  Parameters:
    `result` - set type, i.e. ResultSet.TYPE_XXX
  Returns:
    true if changes are detected by the resultset type
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### insertsAreDetected

    public boolean insertsAreDetected(int type)
                               throws SQLException

  Indicates whether or not a visible row insert can be detected by calling ResultSet.rowInserted().
  Parameters:
    `result` - set type, i.e. ResultSet.TYPE_XXX
  Returns:
    true if changes are detected by the resultset type
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### supportsBatchUpdates

    public boolean supportsBatchUpdates()
                                 throws SQLException

  Indicates whether the driver supports batch updates.
  Returns:
    true if the driver supports batch updates; false otherwise
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### getUDTs

    public ResultSet getUDTs(String catalog,
                             String schemaPattern,
                             String typeNamePattern,
                             int[] types)
                      throws SQLException

  Gets a description of the user-defined types defined in a particular schema. Schema-specific UDTs may have type JAVA_OBJECT, STRUCT, or DISTINCT.

  Only types matching the catalog, schema, type name and type criteria are returned. They are ordered by DATA_TYPE, TYPE_SCHEM and TYPE_NAME. The type name parameter may be a fully-qualified name. In this case, the catalog and schemaPattern parameters are ignored.

  Each type description has the following columns:

  1. TYPE_CAT String => the type's catalog (may be null)
  2. TYPE_SCHEM String => type's schema (may be null)
  3. TYPE_NAME String => type name
  4. CLASS_NAME String => Java class name
  5. DATA_TYPE String => type value defined in java.sql.Types. One of JAVA_OBJECT, STRUCT, or DISTINCT
  6. REMARKS String => explanatory comment on the type

  Note: If the driver does not support UDTs, an empty result set is returned.

  Parameters:
    `catalog` - a catalog name; "" retrieves those without a catalog; null means drop catalog name from the selection criteria
    `schemaPattern` - a schema name pattern; "" retrieves those without a schema
    `typeNamePattern` - a type name pattern; may be a fully-qualified name
    `types` - a list of user-named types to include (JAVA_OBJECT, STRUCT, or DISTINCT); null returns all types
  Returns:
    `ResultSet` - each row is a type description
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### getConnection

    public Connection getConnection()
                             throws SQLException

  Retrieves the connection that produced this metadata object.
  Returns:
    the connection that produced this metadata object
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.